/* chrisvis1 -- a simple OpenGL interface *from* RTcmix-like sends
 * for use eventually to visualize Chris B's lisp stuff
 *
 * BGG
*/

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>
#include <stdlib.h>
#include "aux.h"
#include "3d.h" /* needed for some length calcs */
#include <math.h>

#include "/musr/cmix/H/RTsockfuncs.h"
#include "/musr/cmix/Minc/sockdefs.h"


void display(void) {}

float zval;

void mydisplay(void)
{

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	zval += 0.2;

	glPushMatrix();
		glColor3f(1.0, 1.0, 0.0);
		glTranslatef(0.0, 0.0, zval);
		auxSolidSphere(0.5);
	glPopMatrix();

	glFlush();

	glXSwapBuffers (auxXDisplay(), auxXWindow());


}


void myinit (void) 
{
	GLfloat diffuseMaterial[4];
	GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };

	zval = -10.0;

	glShadeModel(GL_SMOOTH);

	glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuseMaterial);
	glColorMaterial(GL_FRONT, GL_DIFFUSE);
	glEnable(GL_COLOR_MATERIAL);

	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glDepthFunc(GL_LESS);
	glEnable(GL_DEPTH_TEST);
}

void myReshape(int w, int h)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum (-1.0, 1.0, -1.0, 1.0, 1.5, 20.0);
	glMatrixMode(GL_MODELVIEW);
	glViewport(0, 0, w, h);
	glLineWidth(1.0);
}

int main(int argc, char** argv)
{

	auxInitDisplayMode (AUX_DOUBLE | AUX_RGB);
	auxInitPosition (0, 0, 500, 500);
	auxInitWindow (argv[0]);
	myinit();

	auxReshapeFunc (myReshape);

	RTtimeit(0.1, mydisplay);

	auxMainLoop(display);
}

