/* chrisvis3 -- a simple OpenGL interface *from* RTcmix-like sends
 * for use eventually to visualize Chris B's lisp stuff
 *
 * BGG
*/

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>
#include <stdlib.h>
#include "aux.h"
#include "3d.h" /* needed for some length calcs */
#include <math.h>

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <fcntl.h>

#include <sys/prctl.h>
#include <signal.h>


#include "/musr/cmix/H/RTsockfuncs.h"
#include "/musr/cmix/Minc/sockdefs.h"

float cval1, cval2, cval3;

void display(void) {}


void mydisplay(void)
{

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glPushMatrix();
		glColor3f(cval1, cval2, cval3);
		glTranslatef(0.0, 0.0, -5.0);
		auxSolidSphere(0.5);
	glPopMatrix();

	glFlush();

	glXSwapBuffers (auxXDisplay(), auxXWindow());


}


void myinit (void) 
{
	GLfloat diffuseMaterial[4];
	GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };

	glShadeModel(GL_SMOOTH);

	glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuseMaterial);
	glColorMaterial(GL_FRONT, GL_DIFFUSE);
	glEnable(GL_COLOR_MATERIAL);

	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glDepthFunc(GL_LESS);
	glEnable(GL_DEPTH_TEST);

	cval1 = cval2 = cval3 = 0.0;
}

void myReshape(int w, int h)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum (-1.0, 1.0, -1.0, 1.0, 1.5, 20.0);
	glMatrixMode(GL_MODELVIEW);
	glViewport(0, 0, w, h);
	glLineWidth(1.0);
}

int main(int argc, char** argv)
{
	void dosock();

	auxInitDisplayMode (AUX_DOUBLE | AUX_RGB);
	auxInitPosition (0, 0, 500, 500);
	auxInitWindow (argv[0]);
	myinit();

	auxReshapeFunc (myReshape);

	sproc(dosock, PR_SALL);

	RTtimeit(0.1, mydisplay);

	auxMainLoop(display);
}


void dosock()
{
	int s, ns;
	int len;
	struct sockaddr_in sss;
	int err;
	struct sockdata sinfo; /* the RTcmix socket data structure */
	int amt;
	char *sptr;

/* create the socket for listening */
	if( (s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	        perror("socket");
	        exit(1);
	        }

/* set up the socket address */
	bzero(&sss, sizeof(sss));
	sss.sin_family = AF_INET;
	sss.sin_addr.s_addr = INADDR_ANY;
	sss.sin_port = htons(7000); /* now using 7000 for the lisp connection */

	if( err = bind(s, (struct sockaddr *)&sss, sizeof(sss)) < 0) {
	        perror("bind");
	        exit(1);
	}

	listen(s, 1);

	len = sizeof(sss);
	ns = accept(s, (struct sockaddr *)&sss, &len);
	if(ns < 0) {
	        perror("accept");
	        exit(1);
	}


	while(1) {
	        sptr = (char *)&sinfo;
	        amt = read(ns, (void *)sptr, sizeof(struct sockdata));
	        while (amt < sizeof(struct sockdata))
	            amt += read(ns, (void *)(sptr+amt), sizeof(struct sockdata)-amt);

		printf("got some, p[0]: %f, and %f\n",sinfo.data.p[0],sinfo.data.p[1]);
		cval1 = sinfo.data.p[0];
		cval2 = sinfo.data.p[1];
		cval3 = sinfo.data.p[2];
	}
}
